<template>
  <section id="pokemon-page">
    <div class="top-screen">
      <div
        v-for="(pkmn, index) in userPokemons"
        :key="`pkmn-${index}`"
        v-on:click="goTo(pkmn.id)"
        class="pkmn"
      >
        <p>{{pkmn.name}}</p>
        <p>
          <span>100</span>
          <span>{{pkmn.hp}}</span>
        </p>
        <img :src="pkmn.numero < 650 ? require(`@/assets/pkmn/front/${pkmn.numero}.png`) : require(`@/assets/pkmn/front/substitute.png`)" />
      </div>
    </div>

    <div class="middle-screen"></div>

    <div class="bottom-screen">
      <div class="columns">
        <div class="column">
          <button
            :class="`button is-info is-large ${isCatching ? 'is-loading' :''}`"
            @click="catchOne()"
          >
            <span class="icon is-medium">
              <font-awesome-icon icon="exclamation-circle" />
            </span>
            <span>Catch one</span>
          </button>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <button class="button is-danger is-large" @click="goback()">
            <span class="icon is-medium">
              <font-awesome-icon icon="backward" />
            </span>
            <span>Return</span>
          </button>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import router from "../router";

export default {
  name: "pokemon",
  data: function() {
    return {
      userPokemons: [],
      isCatching: false
    };
  },
  mounted() {
    this.retrieveInventory();
  },
  methods: {
    async catchOne() {
      this.isCatching = true;
      await this.$pokemonService.getRandomPokemon(
        res => {
          this.$pokemonService.createCustomPokemon(
            { idPokemon: res.data.id },
            res => {
              this.$inventoryService.addPokemonToInventory(
                {
                  idUser: localStorage.getItem("id_user"),
                  idCustomizePokemon: res.data.res.id
                },
                () => {
                  console.log("add to inventory");
                  this.retrieveInventory();
                  this.isCatching = false;
                  //Scroll to see new pkmn
                  setTimeout(() => {
                    const el = document.querySelector(".top-screen");
                    el.scrollTop = el.scrollHeight;
                  }, 300);
                },
                err => {
                  this.isCatching = false;
                  console.log(err);
                }
              );
            },
            err => {
              this.isCatching = false;
              console.log(err);
            }
          );
        },
        err => {
          this.isCatching = false;
          console.log(err);
        }
      );
    },
    retrieveInventory() {
      this.$userService.inventory(
        res => {
          this.userPokemons = [];
          res.data.userInventory.forEach(el => {
            this.userPokemons.push(el.idCustomizePokemon);
          });
        },
        err => {
          console.log(err);
        }
      );
    },
    goback() {
      router.back();
    },
    goTo(pkmnId) {
      router.push(`/pokemon/${pkmnId}`);
    }
  },
  computed: {},
  components: {}
};
</script>


<style scoped lang="scss">
#pokemon-page {
  .top-screen {
    background-image: url("~@/assets/background-bottom-screen2.png") !important;
    justify-content: center !important;
    flex-direction: row !important;
    flex-wrap: wrap;
    overflow-y: auto !important;
    scrollbar-width: thin;
    > div.pkmn {
      width: 50%;
      font-family: PokemonGb;
      padding: 0.95em 1.5em 0.5em 3em;
      text-align: left;
      height: calc(45px * 2);
      background-image: url("~@/assets/pokemon-box.png") !important;
      height: calc((45px * 2) + 0.5em);
      background-repeat: no-repeat;
      background-size: 100% auto;
      background-position: bottom left;
      color: white;
      display: flex;
      justify-content: space-between;
      flex-direction: column;
      position: relative;
      cursor: pointer;
      > p {
        &:first-child {
          padding: 0.5em 0 0 1.2em;
        }
        &:nth-child(2) {
          display: flex;
          justify-content: space-between;
          flex-direction: row;
        }
      }
      > img {
        position: absolute;
        top: 10px;
        left: 20px;
        width: 50px;
        image-rendering: auto;
      }
    }
  }
}
</style>
